/*********************************************************************************
 * capi_funcs.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/

#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

int capi_call(connection_t *mCON, char *no_source, char *no_target, int controller, int call_anoymous, char *scriptfile, char *delimiter);
void capi_hangup(connection_t *mCON);
void capi_confirm_call(connection_t *mCON);
void capi_hold_call(connection_t* mCON, int hold);
void capi_send_alert_req(connection_t* mCON);
void capi_send_connect_resp(connection_t* mCON, int reject);
void capi_get_dtmf(unsigned char dtmf, int ddi, int con_id);    // Call scriptfile, when DTMF received
void capi_send_dtmf(unsigned char dtmf, int con_id);            // Send DTMF digit
void capi_streaming(connection_t *mCON);                        // CAPI<->VOIP, CAPI<->CAPI, CAPI<->FILE streaming

void capi_facility_dtmf(int enable);                            // enable/disable DTMF (FACILITY_REQ)
void capi_info(long info);
void capi_display_message(connection_t* mCON, char *displaytext);

#if DTMFBOX_USE_CAPI
    char* capi_get_target_no(_cmsg *CMSG, int add_prefix);  // Extract target phone number (called)
    char* capi_get_source_no(_cmsg *CMSG, int add_prefix);  // Extract source phone number (calling)
#endif
