/*********************************************************************************
 * funcs.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/
#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

int account_by_username(char* username);                      // search account by username
int account_by_number(char* number);                          // search account by number

int connection_by_free();                                     // get a free connection id
int connection_by_invite(pjsip_inv_session *inv);             // search connection by invite session (VoIP)
int connection_by_plci(long PLCI);                            // search connection by PLCI (CAPI)
int connection_by_ncci(long NCCI);                            // search connection by NCCI (CAPI)

int transport_by_free();

int client_by_free();                                         // get a free client id
int client_by_address(char *client_addr);                     // search client by address (ip)
int client_account_by_free(int client_id);                    // get a free client-account id
int client_account_by_account(int client_id, int account_id); // search client-account by account-id

int play_by_free(int con_id, int *play_cnt);                  // Get next free playing id in queue and get playing count

char *sip_strip_user(char *sip);                              // get username from sip url
char *sip_strip_host(char *sip);                              // get host from sip url

//int ip_is_public(char *ip_addr);

void init_connections();                                      // initialize connection struct and array
void reset_connection(connection_t *mCON);                    // reset a connection 

void app_dbg3(const char *sender, const char *format, ...);   // application log messages to stdout and/or file
void app_dbg2(const char *sender, const char *format, ...);
void app_dbg(const char *sender, const char *format, ...);
void app_err(const char *sender, const char *format, ...);
void app_msg(const char *sender, const char *format, ...);
void pj_log_func_cb(int level, const char *data, int len);

void adjust_priority();
void boost_priority(int set_priority);
