/*********************************************************************************
 * options.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/
#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

#define MAX_SUBOPTIONS          32
#define MAX_SUBOPTIONS_LENGTH   512

static struct get_options {
    const char *name;
    int type;
    int val;
} get_options;

static enum {     
    OPT_CON,
    OPT_HOOK,    
    OPT_CALL,
    OPT_PLAY,
    OPT_MIXER,
    OPT_RECORD,
    OPT_TONE,
    OPT_DTMF,
    OPT_TEXT,
    OPT_BRIDGE,
    OPT_SCRIPTFILE,
    OPT_DELIMITER,
    OPT_WAITEVENT,
    OPT_STOP,    
    OPT_LIST,
    OPT_TIMER,
    OPT_ENV,
    OPT_VERSION
} app_commands;

static enum {
    OPT_MIX_NONE            = 0,
    OPT_MIX_VOLUME          = 1,
    OPT_MIX_FADE            = 2,
    OPT_MIX_FADE_DURATION   = 4,
    OPT_MIX_TALKOVER_ON     = 8,    
    OPT_MIX_TALKOVER_OFF    = 16,
    OPT_MIX_BACKGROUND_ON   = 32,
    OPT_MIX_BACKGROUND_OFF  = 64
} app_commands_mixer;

static struct get_options par_options[] = {
    { "-con",               0, OPT_CON },
    { "-hook",              0, OPT_HOOK },        
    { "-call",              0, OPT_CALL },
    { "-play",              0, OPT_PLAY },
    { "-playthread",        1, OPT_PLAY },
    { "-playstream",        2, OPT_PLAY },
    { "-playstreamthread",  3, OPT_PLAY },
    { "-mixer",             0, OPT_MIXER },
    { "-record",            0, OPT_RECORD },
    { "-recordstream",      1, OPT_RECORD },
    { "-tone",              0, OPT_TONE },
    { "-dtmf",              0, OPT_DTMF },
    { "-text",              0, OPT_TEXT },
    { "-bridge",            0, OPT_BRIDGE },
    { "-scriptfile",        0, OPT_SCRIPTFILE },
    { "-delimiter",         0, OPT_DELIMITER },
    { "-waitevent",         0, OPT_WAITEVENT },
    { "-stop",              0, OPT_STOP },
    { "-list",              0, OPT_LIST },
    { "-timer",             0, OPT_TIMER },
    { "-env",               0, OPT_ENV },
    { "-version",           0, OPT_VERSION }
};

int param_parser(int argc, char *arg[]);
int param_parser_daemon(int argc, char *arg[], int pid);
int param_parser_daemon_options(int argc, char *arg[], int *play_thread, int *pipe_id);
int param_parser_plugin(int argc, char *arg[], int pid);

void queue_counter(int increment);

static int get_arg_opt(int argc, char *arg[], int *pos, int *option_name, int *option_type, char **options);
static int get_sub_opt(int subopt_cnt, char **options, int *subopt_pos, char *name, char **values, int split_subvalues);

static void print_usage_header(char *title);
static void print_usage_mixer();
static void print_usage_play();
static void print_usage_call();
static void print_usage_hook();
static void print_usage_record();
static void print_usage_waitevent();
static void print_usage_stop();
static void print_usage_tone();
static void print_usage_delimiter();
static void print_usage_scriptfile();
static void print_usage_bridge();
static void print_usage_dtmf();
static void print_usage_timer();
static void print_usage_environment();

static void print_help();
static void print_help_daemon();
static void print_version();
