/*********************************************************************************
 * pipe.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/
#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

#define PIPE_MAX 100

typedef struct pipe_data_t
{
    #if DTMFBOX_WIN32                               // pipe handle
        HANDLE hPipe;        
    #else
        int hPipe;
    #endif

    char name[260];                                 // name of pipe
    int block;                                      // blocking pipe?
    
} pipe_data_t;

pipe_data_t oPIPE[PIPE_MAX];

int pipe_init();
int pipe_create(char *pipe_name, int wait, int read, int write);
int pipe_open(char *pipe_name, int wait, int read, int write);
void pipe_close(int pipe_id);
int pipe_read(int pipe_id, char *buf, int len);
int pipe_write(int pipe_id, char *buf, int len);
