#include "template.plugin.h"

/* Plugin is loaded! */
EXPORT void plugin_init(plugin_exec_cmd cmd) 
{
    dtmfbox = cmd;  
    app_msg("[plugin.template]: Initialized!");
}

/* Plugin is unloaded! */
EXPORT void plugin_close() 
{
    app_msg("[plugin.template]: Destroyed!");
    dtmfbox = NULL;    
}

/* Callback gets called when a new event arrives */
EXPORT void plugin_event(char *scriptfile, char *s_event, char *s_direction, char *s_type, int conid_src, int conid_dst, char *no_src, char *no_dst, char *data, int acc_id) 
{    
    //dtmfbox(2, "-list", "-accounts");
}

/* Callback gets called, when dtmfbox outputs something */
EXPORT void plugin_output(char *output, int pid) 
{ 
    //printf("%s\n", output);    
}

/* Callback gets called, when a new audio frame is available */
EXPORT void plugin_get_frame(char *buf, int buf_size, int conid, int playid, int accid)
{
}

/* Callback gets called, when a new audio frame will be send to the connection */
EXPORT void plugin_put_frame(char *buf, int buf_size, int conid, int recid, int accid)
{
}

/* Callback gets called, when command help is shown */
EXPORT char *plugin_extra_help()
{
    return " dtmfbox template v0.1";
}

/* 
    This function is for implementing own dtmfbox commands. 
    Return > 0, when the parameter(s) are valid, otherwise 0.    
*/
EXPORT int plugin_extra_commands(int argc, char *arg[], int pid)
{
    return 0;
}
