/*********************************************************************************
 * port_rtpstream.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/

#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

typedef struct
{    
    pjmedia_port        *rtp_media_port;
    pjmedia_stream      *rtp_stream_port;    
    pjmedia_stream_info info;
            
    mixer_port_data     mixdata;        
    int                 con_id;

} portdata_rtpstream;

pj_status_t port_rtpstream_init(pj_pool_t *pool, pjmedia_dir dir, pj_uint16_t local_port, const pj_sockaddr_in *rem_addr, int con_id, int play_id, pjmedia_port **p_port);

static pj_status_t port_rtpstream_on_destroy(pjmedia_port *port);
static pj_status_t port_rtpstream_get_frame(pjmedia_port *port, pjmedia_frame *frame);
static pj_status_t port_rtpstream_put_frame(pjmedia_port *port, const pjmedia_frame *frame);
