/*********************************************************************************
 * port_tone.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/

#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

static const short TONE_PROGRESS[5]   = { 425, 425, 1000, 4000, 30000 };
static const short TONE_BUSY[5]       = { 425, 425, 480, 480, 30000 };

typedef struct
{   
    pjmedia_port    *tonegen_port;      // Tone-Generator    

    short           freq1;              // Freq1
    short           freq2;              // Freq2
    short           on_msec;            // On ms
    short           off_msec;           // Off ms
    short           volume;             // Volume    
    int             con_id;             // Connection-ID

} portdata_tone;

pj_status_t port_tone_init(connection_t *mCON, short freq1, short freq2, short on_msec, short off_msec, short volume);
pj_status_t port_tone_close(connection_t *mCON);
pj_status_t port_tone_create(pj_pool_t *pool, connection_t *mCON, pjmedia_port **p_port, short freq1, short freq2, short on_msec, short off_msec, short volume);

void port_tone_ring_thread(void** mCONS);

static pj_status_t port_tone_generate_tones(pjmedia_port *p_port);
static pj_status_t port_tone_get_frame(pjmedia_port *port, pjmedia_frame *frame);
