/*********************************************************************************
 * script_funcs.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/
#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

// script events
enum SCRIPT_EVENTS
{
    CONNECT     = 0,
    DDI         = 1,
    EARLY       = 2,
    CONFIRMED   = 3,
    DTMF        = 4,
    UNCONFIRMED = 5,
    DISCONNECT  = 6,
    TIMER       = 7
};

typedef struct script_event_t
{
    connection_devtype_e    type;
    connection_dir_e        direction;
    enum SCRIPT_EVENTS      s_event;
    char                    scriptfile[256];
    int                     conid_src;
    int                     conid_dst;    
    char                    no_src[MAX_URI_LENGTH];
    char                    no_dst[MAX_URI_LENGTH];
    char                    reserved[512];
    int                     waitevent;
    int                     acc_id;    
} script_event_t;

// Events
#define MAX_SCRIPT_EVENTS 64
script_event_t script_events[MAX_SCRIPT_EVENTS];

int script_do_actions();
int script_event_add(connection_devtype_e type, enum SCRIPT_EVENTS m_event, char *scriptfile, int src_id, int dst_id, char *source_no, char *target_no, char *reserved);
int script_event_run();

// Execute commands
int script_write_output(int iShowConnects, int pipe_id_global);
int script_make_call();
void script_stop_play_record(int *play_id, int *rec_id);
void script_hook_down();
void script_hook_up();
void script_hook_hold(int hold);
void script_hook_reject();
void script_hook_alert();
void script_tone_generator();
void script_bridge();
void script_send_dtmf();
void script_send_text();
void script_timer();
void script_timer_event(pj_timer_heap_t *timer_heap, struct pj_timer_entry *entry);
void script_environment();
void script_change_script();

// Shared Memory 
int open_shared_memory();
int create_shared_memory();
int close_shared_memory(int destroy);
void reset_actions();

