/*********************************************************************************
 * speex.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/

#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

#if !defined(PJMEDIA_HAS_SPEEX_CODEC) || PJMEDIA_HAS_SPEEX_CODEC==0
#define SpeexBits int
#define SpeexMode int
#endif

typedef struct
{    
    void *enc;
    void *dec;
    const SpeexMode *enc_mode;
    const SpeexMode *dec_mode;
    SpeexBits enc_bits;
    SpeexBits dec_bits;
    int clockrate;
    int vad;
    int penh;

} speex_converter_data;

pj_status_t speex_converter_init(speex_converter_data *spx);
pj_status_t speex_converter_close(speex_converter_data *spx);
pj_status_t speex_encode_frame(speex_converter_data *spx, const pjmedia_frame *in_frame, pjmedia_frame *out_frame);
pj_status_t speex_decode_frame(speex_converter_data *spx, const pjmedia_frame *in_frame, pjmedia_frame *out_frame);
