/*********************************************************************************
 * voip_auth.h ($Revision: 189 $)
 *
 * Copyright (c) 2006-2008 Marco Zissen <maz@v3v.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *********************************************************************************/

#pragma once
#define _CRT_SECURE_NO_DEPRECATE 1
#define _CRT_NONSTDC_NO_DEPRECATE 1

#if DTMFBOX_USE_VOIP

#define MD5_APPEND(pms,buf,len) pj_md5_update(pms, (const pj_uint8_t *)buf, len) //pj_md5_update(pms, (const unsigned char*)buf, len)

// Registration functions (client -> dtmfbox - registrar mode)
static void digest2str(const unsigned char digest[], char *output);
int voip_registrar_check_auth_header(pjsip_rx_data* rdata, int *acc_id);
int voip_registrar_req_auth_header(pjsip_rx_data *rdata);
pj_status_t voip_registrar_lookup_account(pj_pool_t *pool, const pj_str_t *realm, const pj_str_t *acc_name, pjsip_cred_info *cred_info);
pj_status_t voip_registrar_verify_account( const pjsip_authorization_hdr *hdr, const pj_str_t *method, const pjsip_cred_info *cred_info);

#endif

// Registration functions (dtmfbox -> registrar - client mode)
int voip_client_register_init(int acc_id);
int voip_client_register_deinit(int acc_id);

static void voip_client_regcb(struct pjsip_regc_cbparam *param);
