#!/var/tmp/sh
. /var/dtmfbox/script.cfg

# Load arguments & settings
EVENT="$1"
TYPE="$2"
DIRECTION="$3"
SRC_ID="$4"
DST_ID="$5"
SRC_NO="$6"
DST_NO="$7"
ACC_ID="$8"
DTMF="$9"

ABORTFILE="$DTMFBOX_PATH/tmp/$SRC_ID.abort_action"
THIS_FILE="$0"

check_callback() {
  let cnt=1
  let ok=1
  while [ "$ok" = "1" ];
  do
    eval CALLBACK="\$CALLBACK${cnt}"
    if [ "$CALLBACK" = "" ]; then break; fi
     
    SPLIT=`echo $CALLBACK | sed 's/\// /g'`
    let i=0;
    for SPLIT_VAL in $SPLIT;
    do
      if [ "$i" = "0" ]; then CALLBACK_TRIGGER_NO="$SPLIT_VAL"; fi
      if [ "$i" = "1" ]; then CALLBACK_CALLING_NO="$SPLIT_VAL"; fi
      if [ "$i" = "2" ]; then CALLBACK_TRIGGER_ACC="$SPLIT_VAL"; fi
      if [ "$i" = "3" ]; then CALLBACK_CALLING_ACC="$SPLIT_VAL"; fi
      if [ "$i" = "4" ]; then CALLBACK_CALLING_CTRL="$SPLIT_VAL"; fi
      let i=i+1;
    done
    if [ "$CALLBACK_CALLING_NO" = "" ]; then CALLBACK_CALLING_NO="$DST_NO"; fi
    if [ "$CALLBACK_CALLING_ACC" = "" ]; then CALLBACK_CALLING_ACC="$ACC_ID"; fi
    if [ "$CALLBACK_TRIGGER_ACC" = "" ]; then CALLBACK_TRIGGER_ACC="$ACC_ID"; fi

    VALID_CB=`echo $DST_NO | sed s/$CALLBACK_TRIGGER_NO/OK/g`
    if [ "$VALID_CB" = "OK" ] && [ "$CALLBACK_TRIGGER_ACC" = "$ACC_ID" ]; 
    then
         CALLBACK_CALLING_NO=`echo $DST_NO | sed "s/$CALLBACK_TRIGGER_NO/$CALLBACK_CALLING_NO/g"`
         echo "CbCt-Script: valid callback! $CALLBACK_CALLING_ACC -> $CALLBACK_CALLING_NO (Ctrl: $CALLBACK_CALLING_CTRL)"
         echo "CB" > "$ABORTFILE"
         return 1
    else
         VALID_CB=""
    fi

    let cnt=cnt+1
  done
}

check_callthrough() {
  let cnt=1
  let ok=1
  while [ "$ok" = "1" ];
  do
    eval CALLTHROUGH="\$CALLTHROUGH${cnt}"
    if [ "$CALLTHROUGH" = "" ]; then break; fi
     
    SPLIT=`echo $CALLTHROUGH | sed 's/\// /g'`
    let i=0;
    for SPLIT_VAL in $SPLIT;
    do
      if [ "$i" = "0" ]; then CALLTHROUGH_TRIGGER_NO="$SPLIT_VAL"; fi
      if [ "$i" = "1" ]; then CALLTHROUGH_TRIGGER_ACC="$SPLIT_VAL"; fi
      let i=i+1;
    done
    if [ "$CALLTHROUGH_TRIGGER_ACC" = "" ]; then CALLTHROUGH_TRIGGER_ACC="$ACC_ID"; fi

    VALID_CT=`echo $DST_NO | sed s/$CALLTHROUGH_TRIGGER_NO/OK/g`
    if [ "$VALID_CT" = "OK" ] && [ "$ACC_ID" = "$CALLTHROUGH_TRIGGER_ACC" ];
    then         
         echo "CbCt-Script: valid callthrough! $CALLTHROUGH_TRIGGER_ACC -> $CALLTHROUGH_TRIGGER_NO"
         echo "CT" > "$ABORTFILE"
         $DTMFBOX $SRC_ID -hook up -scriptfile "$0"         
         $DTMFBOX $SRC_ID -goto "menu:callthrough_pin"
         return 1
    else
         VALID_CT=""
    fi

    let cnt=cnt+1
  done
}

if [ "$EVENT" = "CONNECT" ] && [ "$DIRECTION" = "INCOMING" ];
then
  # remove address from number (voip only)
  if [ "$TYPE" = "VOIP" ];
  then
     DST_NO=`echo $DST_NO | sed 's/\(.*\)@.*/\1/g'`
  fi

  #############################################
  # Callback 
  #############################################
  check_callback
  if [ "$VALID_CB" = "OK" ];
  then
     $DTMFBOX $SRC_ID -scriptfile "$THIS_FILE"
     exit 1
  fi

  #############################################
  # Callthrough
  #############################################
  check_callthrough
  if [ "$VALID_CT" = "OK" ];
  then
    $DTMFBOX $SRC_ID -hook up -scriptfile "$THIS_FILE"         
    $DTMFBOX $SRC_ID -goto "menu:callthrough_pin"
    exit 1
  fi
fi


if [ "$EVENT" = "DISCONNECT" ];
then
  if [ -f "$ABORTFILE" ];
  then
    CBCT_TYPE=`cat "$ABORTFILE"`

    # callback on disconnect
    if [ "$CBCT_TYPE" = "CB" ];
    then
      check_callback
      if [ "$VALID_CB" = "OK" ];
      then
        sleep 3
        echo "CbCt-Script: Callback $CALLBACK_CALLING_ACC -> $CALLBACK_CALLING_NO (Ctrl: $CALLBACK_CALLING_CTRL)"
        CON_ID=`$DTMFBOX -call "$CALLBACK_CALLING_ACC" "$CALLBACK_CALLING_NO" "$CALLBACK_CALLING_CTRL"`
        $DTMFBOX $CON_ID -scriptfile none
        $DTMFBOX $CON_ID -goto "menu:callthrough_pin"
        exit 1;
      fi
    fi
   
    rm "$ABORTFILE"
  fi
fi
