#!/var/tmp/sh

if [ "$HELPPAGE" = "" ]; then HELPPAGE="vorwort"; fi

#
# Basiseinstellungen
#
if [ "$HELPPAGE" = "basiseinstellungen" ]; then
echo '<a name="basiseinstellungen" href="#basiseinstellungen"></a>'
show_title "Basiseinstellungen"
cat << EOF
Unter <a href="$MAIN_CGI&page=dtmfbox_cfg" target="_new">Basiseinstellungen</a> wird die Datei dtmfbox.cfg bearbeitet.<br><br>
Diese stellt die Grundkonfiguration des Programms dar. Standardmig ist die Datei so eingerichtet, <br>
dass nur wenige nderungen vorgenommen werden mssen, wie z.B. die Einrichtung von <a href="$MAIN_CGI&page=help&help=accounts">Accounts</a>.<br><br>

Der Aufbau ist in <font class='code'>[sektionen]</font> unterteilt. Kommentare werden mit Doppel-Slashes gekennzeichnet: <font class='code'>// Kommentar</font><br><br>

Die Datei ist kommentiert und sollte Aufschluss ber die mglichen Schalter bieten.
EOF
fi

#
# Vorwort
#
if [ "$HELPPAGE" = "vorwort" ]; then
echo '<a name="vorwort" href="#vorwort"></a>'
show_title "Vorwort"
cat << EOF
	Die dtmfbox ist eine Softswitch Applikation, welche SIP und CAPI untersttzt.<br><br>
	Mithilfe von Shell-Skripten und Plugins lassen sich Steuerungen durchfhren, wie z.B. ein Gesprch
	annehmen, Wave-Dateien aufzeichnen/abspielen, Mensteuerungen, usw..
	Telefonie-Ereignisse werden dabei an die Skripte und Plugins weitergerreicht. Befehle lassen sich ber Kommandozeile oder ber eine Funktion innerhalb der Plugins aufrufen.
	<br><br>

	Diese Version der dtmfbox beinhaltet ein Plugin und mehrere Skripte:<br><br>
	<i>menu.plugin.so</i> dient dazu, eine komfortable Menschnittstelle zu bieten, welche sich 
	ber eine Konfigurationsdatei (<a href="$MAIN_CGI&page=menu_cfg" target="_new">menu.cfg</a>) anpassen lsst. <br>
	Zudem lassen sich hier <a href="$MAIN_CGI&page=help&help=menu_action">Aktionen</a> einstellen, welche zu bestimmten Ereignissen ausgefhrt werden sollen.	
	<br><br>

	Die Skripte bieten im Standard folgende Funktionen:
	<ul>
		<li><b>Anrufbeantworter</b></li>
		    <i>Ansage/Endansage, Mailversand/FTP-Streaming, Schedule, Aufnahme-/Ansagemodus</i>		
		</li><p></p>

		<li><b>Anrufbeantworter Fernabfrage und interne Abfrage</b><br>
		    <i>Aufnahmen Abspielen, Aufnahmen lschen, Ansagen aufnehmen, Aktivieren/Deaktivieren</i>
		</li><p></p>

		<li><b>DTMF-Befehle</b><br>
		    <i>Men-Tasten mit Shellskripten belegen (unendlich viele!)</i>
		</li><p></p>

		<li><b>Callback & Callthrough</b><br>
		    <i>Callback/Callthrough-Regeln per Regular Expression. Weiterleitung zum Callthrough-Men...</i>
		</li><p></p>

		<li><b>Sonstiges</b><br>
		    <i>Fritz!Box Infos, Wettervorhersage (Podcast), Web-Radio, CheckMailD abfragen</i>
		</li>		
	</ul>

	Die Skripte lassen sich nach belieben erweitern/bearbeiten (<a href="$MAIN_CGI&page=scripts" target="_new">Link</a>). Ebenso das Men (<a href="$MAIN_CGI&page=menu_cfg" target="_new">Link</a>).<br><br>
	Skripte und Einstellungen werden bei der Standalone-Version in der <i>/var/flash/debug.cfg</i> gespeichert. <br>
	Bei der USB-Version wird nur ein Start-Skript in die <i>/var/flash/debug.cfg</i> geschrieben.<br>
	Die Daten werden komprimiert abgelegt!<br><br>

	<b>License:</b>
<ul>
<pre class='code' style='width:550px'>
 dtmfbox Copyright (c) 2006-2008 Marco Zissen (maz@v3v.de)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
</pre>
</ul>
EOF
fi


#
# Getting started...
#
if [ "$HELPPAGE" = "getting_started" ]; then
echo '<a name="getting_started" href="#getting_started"></a>'
show_title "Getting started..."
cat << EOF
<ul>
	<table border="0" width="300">
	<tr><td width="200">1.) <a href="$MAIN_CGI&page=help&help=accounts">Account(s) einrichten</a></td><td>(<a href="$MAIN_CGI&page=dtmfbox_cfg" target="_new">dtmfbox.cfg</a>)</tr>
	<tr><td width="200">2.) <a href="$MAIN_CGI&page=help&help=internes_menu">Interne Mens zuweisen</a></td><td>(<a href="$MAIN_CGI&page=dtmfbox_cfg" target="_new">dtmfbox.cfg</a>)</tr>
	<tr><td width="200">3.) <a href="$MAIN_CGI&page=help&help=skripteinstellungen">Skripteinstellungen</a></td><td>(<a href="$MAIN_CGI&page=script_cfg" target="_new">script.cfg</a>)</tr>
	<tr><td width="200">4.) <a href="$MAIN_CGI&page=help&help=status">dtmfbox starten</a></td><td>(<a href="$MAIN_CGI&page=status" target="_new">Status</a>)</tr>
	</table>
</ul>
EOF
fi

#
# Status
#
if [ "$HELPPAGE" = "status" ]; then
echo '<a name="status" href="#status"></a>'
show_title "Status"
cat << EOF
Auf der <a href="$MAIN_CGI&page=status" target="_new">Statusseite</a> befindet sich der aktuelle Dienste-Status der dtmfbox.<br><br>
Hier kann die dtmfbox manuell gestartet und gestoppt werden. Zustzlich kann die Programmausgaben mitgeloggt werden.<br><br>

Die Befehle fr die Konsole sehen folgendermaen aus:
<pre class='code'>
rc.dtmfbox start|stop|restart	# starten, stoppen, neu starten.
rc.dtmfbox foreground		# im Vordergrund starten, mit Skriptausgaben, fr Tests.
rc.dtmfbox log			# geloggt starten, ohne Skriptausgaben.
</pre>

Ist die dtmfbox gestartet, werden alle Accounts (mit Registrierungsstatus), alle aktuellen Verbindungen und alle angemeldeten Clients angezeigt.
Falls Nachrichten auf den Anrufbeantworter vorhanden sein sollten, werden diese ebenfalls auf der Seite "<a href='$MAIN_CGI&page=status' target='_new'>Status</a>" angezeigt.

EOF
fi


#
# Accounts einrichten
#
if [ "$HELPPAGE" = "accounts" ]; then
echo '<a name="accounts" href="#accounts"></a>'
show_title "Accounts einrichten"
cat << EOF
	Grundvorraussetzung ist das Einrichten von Accounts.<br><br>
	Unter <a href="$MAIN_CGI&page=dtmfbox_cfg" target="_new">Basiseinstellungen</a> knnen bis zu 10 Accounts eingerichtet werden.
	Die Sektionen fangen bei <font class='code'>[acc1]</font> an und hren bei  <font class='code'>[acc10]</font> auf.<br>
	Einzelne Accounts knnen mittels <font class='code'>'active='</font> aktiviert (<font class='code'>1</font>), bzw. deaktiviert (<font class='code'>0</font>) werden.
	<p>
	Es gibt vier Arten, Accounts einzurichten:
	<ul>
		<a name="m1" href="#m1"></a>
		<li><b>ISDN/Analog (ber CAPI)</b><p></p>

		Bei ISDN ist dies die optimale Wahl. Bei Analog gibt es gewisse Einschrnkungen (siehe unten).<br><br>

<i>Beispiel (ISDN):</i><br>
<pre class='code'>
[acc1]
active=1				// 1=aktiviert, 0=deaktiviert
name=ISDN1				// Beliebiger Name
number=1234567				// MSN ohne Vorwahl
type=capi				// type=capi
capi_controller_out=1			// Standardcontroller fr ausgehende Verbindungen
</pre>

<i>Beispiel (Analog):</i><br>
<pre class='code'>
[acc1]
active=1				// 1=aktiviert, 0=deaktiviert
name=1234567				// Anschlussnummer ohne Vorwahl
number=unknown				// unknown
type=capi				// type=capi
capi_controller_out=4			// Standardcontroller fr ausgehende Verbindungen
</pre>
		Bei Analog wie auch ISDN wird die Nummer immer OHNE VORWAHL angegeben!<br>
		Bei ISDN darf der <font class='code'>name=</font> beliebig sein und <font class='code'>number=</font> muss der MSN entsprechen.<br>
		Bei Analog muss <font class='code'>number=</font> auf <font class='code'>'unknown'</font> gestellt werden. Die Anschlussnummer wird unter <font class='code'>name=</font> hinterlegt.<br>
		<font class='code'>capi_controller_out=</font> ist der Standardcontroller, der fr ausgehende Verbindungen verwendet wird (ISDN=1, Analog=4).<br><br>

		Die Accounts stehen unter <a href="$MAIN_CGI&page=status" target="_new">Status</a> solange auf "Pending", bis ein Anruf eingeht, bzw. ein Anruf durchgefhrt wird.<br><br>

		<i>Einschrnkungen Analog:</i><br>
		Da der POTS-Anschluss der FritzBox nicht wie der S0 arbeitet, werden nur eingehende Gesprche erkannt, aber keine Ausgehenden.<br>
		Dies bedeutet, dass man das Men nicht intern, ber eine Kurzwahl, erreichen kann. <br>
		Um dennoch das Men abzuhren, knnen Analog-Telefone ber SIP-Registrar angebunden werden.
		</li><p></p>

		<a name="m2" href="#m2"></a>
		<li><b>ISDN/Analog (ber SIP-Registrar)</b><p></p>
		Analog/ISDN-Telefone knnen optional ber SIP angemeldet werden.<br>
		Dazu muss der Registrar-Mode der dtmfbox aktiviert und die Anmeldedaten fr den Client hinterlegt werden:<p></p>
		
<i>Beispiel (Analog):</i><br>
<pre class='code'>
[voip]
voip=1					// VoIP aktivieren!
voip_registrar=1			// Registrar-Modus an!
voip_max_clients=4			// Anzahl der Clients, die sich anmelden drfen
voip_realm=fritz.box			// Realm fr den Registrar
voip_udp_port=5061			// Port, fr SIP
voip_rtp_start=4000			// Start-Port, fr RTP/RTCP
<a href="$MAIN_CGI&page=help&help=basiseinstellungen">// ...			 		// siehe auch Basiseinstellungen</a>

[acc1]
active=1				// Analog-Account
name=1234567
number=unknown
type=capi
capi_controller_out=4
registrar_active=1			// Aktiviert die Anmeldung an die dtmfbox
registrar_user=1234567			// Username
registrar_pass=secret			// Passwort
</pre>

		Im AVM-WebIf wird nun ein Internettelefonie-Account angelegt.<br>
		In diesem Beispiel wrde man als Registrar "127.0.0.1:5061" oder "fritz.box:5061" angeben mit dem Usernamen "1234567" und dem Passwort "secret".<br><br>
		Bei erfolgreicher Anmeldung wird der Client unter <a href="$MAIN_CGI&page=status" target="_new">Status</a> angezeigt.
		</li><p></p>

		<a name="m3" href="#m3"></a>
		<li><b>VoIP (ber CAPI)</b><p></p>
		Um die bereits registrierten Internettelefonie-Accounts des voipd zu verwenden, kann man diese ebenfalls ber CAPI registrieren.<br>
		Hierbei ist wichtig, welche Position der Internettelefonie-Account in der Liste hat (AVM-WebIf).<p></p>

<i>Beispiel (1. Internettelefonie-Account):</i><br>
<pre class='code'>
[acc1]
active=1				// 1=aktiviert, 0=deaktiviert
name=1234567				// Beliebiger Name
number=0#1234567			// 0# = Erster Account, 1234567=Internetrufnummer
type=capi				// type=capi
capi_controller_out=5			// Standardcontroller fr ausgehende Verbindungen
</pre>
		
<i>Beispiel (4. Internettelefonie-Account):</i><br>
<pre class='code'>
[acc1]
active=1				// 1=aktiviert, 0=deaktiviert
name=7654321				// Beliebiger Name
number=3#7654321			// 3# = Vierter Account, 7654321=Internetrufnummer
type=capi				// type=capi
capi_controller_out=5			// Standardcontroller fr ausgehende Verbindungen
</pre>
		</li><p></p>

		<a name="m4" href="#m4"></a>
		<li><b>VoIP (ber SIP)</b><p></p>
		Um SIP-Accounts direkt ber die dtmfbox zu registrieren, mssen die Provider-Daten des Registrars eingetragen werden<p></p>

<i>Beispiel (SIP-Account):</i><br>
<pre class='code'>
[voip]
<a href="$MAIN_CGI&page=help&help=basiseinstellungen">// ...	 				// siehe Basiseinstellungen</a>

[acc1]
active=1				// 1=aktiviert, 0=deaktiviert
name=SIP Account			// Beliebiger Name (wird als Display-Name verwendet)
number=1234567  			// Internetrufnummer
type=voip				// type=voip

voip_registrar=sip.registrar.de		// Registrar-Server
voip_realm=registrar.de			// SIP-Realm (* fr automatische Suche)
voip_user=MeinUsername			// Username
voip_pass=MeinPasswort			// Passwort
voip_do_not_register=0			// 1=Keine Registrierung, 0=Registrieren
voip_id=				// Optional: SIP-ID (MeinUsername@sip.registrar.de)
voip_proxy=				// Optional: Proxy
voip_contact=				// Optional: SIP-Contact
</pre>

		Manchmal wird fr die Registrierung ein STUN-Server bentigt. Bei NAT-Problemen ist manchmal auch die Aktivierung von ICE ntig (z.B. One-Way Audio).
		Nheres siehe auch <a href="$MAIN_CGI&page=help&help=basiseinstellungen">Basiseinstellungen</a>.<br><br>
		Provider-Beispiele:<p></p>

<i>Beispiel (1&1):</i><br>
<pre class='code'>
[voip]
<a href="$MAIN_CGI&page=help&help=basiseinstellungen">// ...	 				// siehe Basiseinstellungen</a>
voip_stun=stun.1und1.de
voip_stun_port=3478
voip_ice=1

[acc1]
active=1				// 1=aktiviert, 0=deaktiviert
name=49123456789			// Beliebiger Name (wird als Display-Name verwendet)
number=49123456789  			// Internetrufnummer
type=voip				// type=voip

voip_registrar=sip.1und1.de		// Registrar-Server (oder IP direkt: 212.227.15.197)
voip_realm=1und1.de			// SIP-Realm (* fr automatische Suche)
voip_user=49123456789			// Username
voip_pass=MeinPasswort			// Passwort
voip_do_not_register=0			// 1=Keine Registrierung, 0=Registrieren
voip_id=49123456789@1und1.de		// Optional: SIP-ID (MeinUsername@sip.registrar.de)
voip_proxy=				// Optional: Proxy
voip_contact=				// Optional: SIP-Contact
</pre>

<i>Beispiel (Sipgate):</i><br>
<pre class='code'>
[voip]
<a href="$MAIN_CGI&page=help&help=basiseinstellungen">// ...	 				// siehe Basiseinstellungen</a>
voip_stun=stun.1und1.de
voip_stun_port=3478
voip_ice=1

[acc1]
active=1				// 1=aktiviert, 0=deaktiviert
name=49123456789			// Beliebiger Name (wird als Display-Name verwendet)
number=49123456789  			// Internetrufnummer
type=voip				// type=voip

voip_registrar=sipgate.de		// Registrar-Server 
voip_realm=sipgate.de			// SIP-Realm (* fr automatische Suche)
voip_user=55112233			// Username
voip_pass=MeinPasswort			// Passwort
voip_do_not_register=0			// 1=Keine Registrierung, 0=Registrieren
voip_id=55112233@sipgate.de		// Optional: SIP-ID (MeinUsername@sip.registrar.de)
voip_proxy=				// Optional: Proxy
voip_contact=				// Optional: SIP-Contact
</pre>
		</li>
	</ul>
EOF
fi

#
# Internes Men
#
if [ "$HELPPAGE" = "internes_menu" ]; then
echo '<a name="internes_menu" href="#internes_menu"></a>'
show_title "Internes Men"
cat << EOF
Das interne Men kann ber Kurzwahlen erreicht werden.<br>
Dies gilt fr ISDN-Accounts, wie auch Accounts, welche ber den Registrar-Mode angebunden sind (SIP-Clients angemeldet an dtmfbox).<br><br>

Damit das Telefon auf die Kurzwahl reagiert, mssen zwei Eintrge unter <font class='code'>[accX]</font> eingefgt werden (X=Account-ID):<br><br>

<i>Beispiel:</i><br>
<pre class='code'>
[acc1]
<a href="$MAIN_CGI&page=help&help=accounts">// ...	 					// siehe Accounts</a>
menu_keycode=800				// Kurzwahl (hier 800)
menu_entry=menu:main				// Men-Einstiegspunkt (menu:main ist das Hauptmen)
</pre>

Von Auerhalb kann das Men ber den Anrufbeantworter (AB-PIN-Eingabe, whrend der Ansage), bzw. ber Callback/Callthrough erreicht werden.<br><br>

<i>Hinweis:</i><br>
Es kann vorkommen, dass das Telefon (ISDN) nicht auf die Kurzwahl reagiert. Man kann jedoch im AVM-WebIf unter Telefoniegerte\Festnetz eine zustzliche Nummer anlegen (in dem Fall die gewnsche Kurzwahl, z.B. 800). Danach kann man das interne Men entweder ber 800, bzw **##800 erreichen.

EOF

fi


#
# Men bearbeiten
#
if [ "$HELPPAGE" = "menu" ]; then
show_title "Men bearbeiten"
cat << EOF
Das Men kann individuell bearbeitet werden.<br>
Es ist ebenfalls in <font class='code'>[sektionen]</font> unterteilt, jedoch werden diese anders interpretiert.<br><br>

Es gibt vier Sektionen:
<ul>
	<li><a href="$MAIN_CGI&page=help&help=menu_menu"><b>[menu: ... ]</b></a><br>
	Stellt ein Men dar.<br>
	Es knnen DTMF-Zeichen hinterlegt werden, welche ein Men <font class='code'>[menu:]</font> , ein Skript <font class='code'>[script:]</font> oder eine Library-Funktion <font class='code'>[lib:] aufrufen.</font>
	</li><p></p>

	<li><a href="$MAIN_CGI&page=help&help=menu_script"><b>[script: ... ]</b></a><br>
	Fhrt ein Skript aus, wenn die Sektion aufgerufen wird.<br>
	Es kann ein Skript hinterlegt werden, welches ausgefhrt werden soll (inkl. Parameter).
	</li><p></p>

	<li><a href="$MAIN_CGI&page=help&help=menu_lib"><b>[lib: ... ]</b></a><br>
	Fhrt eine Funktion in einer Library aus, wenn die Sektion aufgerufen wird.<br>
	Es kann eine Library und ein Funktionsname hinterlegt werden (inkl. Parameter).
	</li><p></p>

	<li><a href="$MAIN_CGI&page=help&help=menu_action"><b>[action: ... ]</b></a><br>
	Fhrt eine <font class='code'>[script:]</font> oder <font class='code'>[lib:]</font> Sektion aus, bei bestimmten Ereignissen.<br>
	Es werden die Ereignisse und eine <font class='code'>[script:]</font> oder <font class='code'>[lib:]</font> Sektion angegeben.
	</li><p></p>
</ul>

Alle Men-, Skript- und Library-Sektionen mssen einen eindeutigen Namen besitzen.<br>
Der Name wird nach dem Doppelpunkt gesetzt. Z.B. <font class='code'>[menu:my_menu1], [script:my_script1]</font>, usw...<br><br>

Es knnen beim Aufruf der Sektionen auch Parameter bergeben werden (bis zu 32):
<pre class='code'>
[menu:main]
say=Hauptmenue
1=script:myscript("Hallo", "Test")		     // "Hallo" und "Test" an Skript bergeben
2=menu:zweites_menu("Hallo2")			     // "Hallo2" an Men bergeben

[menu:zweites_menu]
say=Zweites Menue
1=script:myscript("%\$1%", "Test2")		     // %\$1%="Hallo2" u. "Test2" an Skript bergeben
*=menu:main

[script:myscript]
cmd=/var/script/myscript.sh(/var/script/myscript.sh, "%\$1%", "%\$2%")     // 1. und 2. Argument an Skript bergeben
</pre>
Die Parameter stehen dann als Argumente innerhalb der Sektion zur Verfgung (von <font class='code'>%\$1%</font> bis <font class='code'>%\$32%</font>)<br><br>

Es gibt noch weitere Platzhalter:
<pre class='code'>
%event%		// Aktuelles Ereignis (DDI, EARLY, CONNECT, CONFIRMED, UNCONFIRMED, DISCONNECT)
%direction%	// Verbindungsrichtung (INCOMING, OUTGOING)
%type%		// Verbindungstyp (CAPI, VOIP, USER)
%src_id%	// Source Connection-ID (eigene Verbindungs-ID)
%dst_id%	// Target Connection-ID (Gesprchspartner-ID)
%src_no%	// Rufnummer (Account/MSN)
%dst_no%	// Anrufer oder Zielrufnummer
%acc_id%	// Account-ID
%data%		// DTMF-Zeichen (Aktuell, einzelnes Zeichen)
%dtmf%		// DTMF-Zeichen (Buffer, gesammelte Zeichen)
</pre>
EOF
fi

#
# [menu: ... ]
#
if [ "$HELPPAGE" = "menu_menu" ];
then
echo '<a name="menu_menu" href="#menu_menu"></a>'
show_title "[menu: ... ]"
cat << EOF
Ein <font class='code'>[menu:XYZ]</font> stellt eine Men-Sektion dar. In dem Fall mit dem eindeutigen Namen XYZ.<br><br>

Ein Men kann beliebig lang sein. Es knnen einzelne DTMF-Zeichen mit Untermens, Skripten und Library-Funktionen verknpft werden.
Ganze DTMF-Zeichenfolgen sind ebenfalls mglich.<br><br>

<i>Beispiel (einzelne DTMF-Zeichen):</i>
<pre class='code'>
[menu:main]
say=1 Erstes Menue, 2 Zweites Menue
1=menu:menu_1
2=menu:menu_2

[menu:menu_1]
say=Menu 1. Zurueck mit *
*=menu:main

[menu:menu_2]
say=Menu 2. Zurueck mit *
*=menu:main
</pre>

<i>Beispiel (mehrere DTMF-Zeichen):</i>
<pre class='code'>
[menu:main]
say=101# Erstes Menue, 102# Zweites Menue
101#=menu:menu_1
102#=menu:menu_2

[menu:menu_1]
say=Menu 1. Zurueck mit *
*=menu:main

[menu:menu_2]
say=Menu 2. Zurueck mit *
*=menu:main
</pre>

Wird <font class='code'>say=</font> mit angegeben, wird das <font class='code'>text2speech=</font> Skript ausgefhrt, welches unter den <a href="$MAIN_CGI&page=dtmfbox_cfg" target="_new">Basiseinstellungen</a> hinterlegt ist. <br>
Der angegebende Text wird auf das Telefon ausgegeben, solange <a href="http://espeak.sourceforge.net/" target="_new">eSpeak</a> verwendet wird (<a href="$MAIN_CGI&page=script_cfg" target="_new">Skripteinstellungen > <font class='code'>ESPEAK_INSTALLED=X</font></a>).
EOF
fi

#
# [script: ... ]
#
if [ "$HELPPAGE" = "menu_script" ];
then
echo '<a name="menu_script" href="#menu_script"></a>'
show_title "[script: ... ]"
cat << EOF
Ein <font class='code'>[script:XYZ]</font> stellt eine Skript-Sektion dar. In dem Fall mit dem eindeutigen Namen XYZ.<br><br>
Skripte knnen von Mens <font class='code'>[menu:]</font> und Aktionen <font class='code'>[action:]</font> aufgerufen werden.
<br><br>
<i>Beispiel 1:</i>
<pre class='code'>
[menu:main]
say=1 Erste Skript Funktion, 2 Zweite Skript Funktion.
1=script:myscript(1)		// 1 bergeben
2=script:myscript(2)		// 2 bergeben

[script:myscript]
say=Skript %\$1% ausfhren	// say "Skript X ausfhren"
cmd=/var/dtmfbox/script/myscript1.sh(/var/dtmfbox/script/myscript1.sh, "%\$1%", "%src_id%")
</pre>
In dem obigen Beispiel wird zweimal das selbe Skript aufgerufen, jedoch mit unterschiedlichen Parametern (1 und 2). <br>
Zustzlich wird der Platzhalter <font class='code'>"%src_id%"</font> an das Skript <font class='code'>"myscript1.sh"</font> bergeben.<br>
Im Skript stehen die Parameter dann als Argumente zur Verfgung (\$1="1" oder "2" und \$2="%src_id%").<br><br>

Auch hier kann <font class='code'>say=</font> angegeben werden, um einen Text auszugeben.<br><br>

<i>Beispiel 2 (selbes Skript wie oben, nur dynamisch):</i>
<pre class='code'>
[menu:main]
say=Skript-Funktion aufrufen
#=script:myscript(%dtmf%)	// DTMF-Zeichen bergeben

[script:myscript]
say=Skript %\$1% ausfhren	// say "Skript X ausfhren"
cmd=/var/dtmfbox/script/myscript1.sh(/var/dtmfbox/script/myscript1.sh, "%\$1%", "%src_id%")
</pre>
In dem obigen Beispiel wird ebenfalls das Skript aufgerufen, jedoch etwas dynamischer.<br>
Anstelle einzelne Skriptaufrufe fr bestimmte Tasten festzulegen, wird beim Drcken der #-Taste der ganze DTMF-Buffer an das Skript bergeben.
Solange # nicht eingegeben wurde, werden die DTMF-Zeichen "gesammelt".<br>
Wird z.B. <font class='code'>100#</font> eingegeben, so steht in <font class='code'>%dtmf%</font> ebenfalls <font class='code'>"100#"</font>. In <font class='code'>%data%</font> steht immer das letzte Zeichen, welches in dem Fall <font class='code'>"#"</font> wre.
<br><br>
In <font class='code'>cmd=</font> wird das eigentliche Skript angegeben. Der Aufruf ist wie bei der Funktion 'execl' unter C.<br>
Die Skriptdatei wird vor der Klammer und als erster Parameter angegeben.
EOF
fi

#
# [lib: ... ]
#
if [ "$HELPPAGE" = "menu_lib" ];
then
echo '<a name="menu_lib" href="#menu_lib"></a>'
show_title "[lib: ... ]"
cat << EOF
Ein <font class='code'>[lib:XYZ]</font> stellt eine Library-Sektion dar. In dem Fall mit dem eindeutigen Namen XYZ.<br><br>

Libraries knnen von Mens <font class='code'>[menu:]</font> und Aktionen <font class='code'>[action:]</font> aufgerufen werden.<br>
Hierbei wird gezielt eine Funktion in einer Library aufgerufen. Die Libraries mssen nicht zwingend als Plugin eingebunden werden.<br><br>

<i>Beispiel:</i>
<pre class='code'>
[menu:main]
1=lib:speak("Hallo 1")
2=lib:speak("Hallo 2")
3=lib:speak("Hallo 3")

[lib:speak]
library=/var/dtmfbox/menu.plugin.so
function=speak(%src_id%,"%\$1%")
</pre>
Es knnen char*-und integer-Datentypen bergeben werden. Integer-Werte werden ohne Anfhrungsstriche angegeben.<br>
In dem obigen Beispiel wird die Funktion "speak()" in der Library menu.plugin.so aufgerufen. Der erste Parameter ist ein Integer, der Zweite ein char*.
EOF

fi

#
# [action: ... ]
#
if [ "$HELPPAGE" = "menu_action" ];
then
echo '<a name="menu_action" href="#menu_action"></a>'
show_title "[action: ... ]"
cat << EOF
Ein <font class='code'>[action:XYZ]</font> stellt eine Aktion dar, die bei bestimmten Ereignissen ausgelst wird. In dem Fall mit dem eindeutigen Namen XYZ.<br><br>
Stimmen die angegebenen Ereignisse der Aktion berein, wird ein Skript oder eine Library aufgerufen. <br>
Im Gegensatz zu den anderen Sektionen, wird eine Aktion nicht in Mens verwendet.<br><br>

<i>Beispiel:</i>
<pre class='code'>
[action:action_1]
event=CONNECT
//type=
direction=INCOMING
//src_id=
//dst_id=
//src_no=
dst_no=0049301234567
//data=
action=script:action_hookup

[script:action_hookup]
cmd=/var/action_hookup.sh(/var/action_hookup.sh, "%event%", "%type%", "%direction%", "%src_id%", "%dst_id%")
</pre>
Wenn:<br>
<font class='code'>%event%="CONNECT"</font> und <font class='code'>%direction%="INCOMING"</font> und <font class='code'>%dst_no%="0049301234567"</font>, <br>
Dann:<br>
<font class='code'>"action_hookup.sh"</font> ausfhren (und Platzhalter bergeben).<br><br>
Innerhalb des Skriptes knne man z.B. die Verbindung annehmen (<font class='code'>\$DTMFBOX \$4 -hook up</font>).
<p></p>
<i>Hinweis:</i><br>
Bei mehrere Aktionen werden diese nacheinander ausgefhrt (nach Namen sortiert).<br>
Eine Erluterung zu den Ereignissen befindet sich <a href="$MAIN_CGI&page=help&help=ereignisse">hier</a>. Eine Erluterung zu den Befehlen, <a href="$MAIN_CGI&page=help&help=befehle">hier</a>.
EOF
fi


#
# Skripteinstellungen
#
if [ "$HELPPAGE" = "skripteinstellungen" ];
then
echo '<a name="skripteinstellungen" href="#skripteinstellungen"></a>'
show_title "Skripteinstellungen"

cat << EOF
Unter dem Menpunkt "<a href='$MAIN_CGI&page=script_cfg' target='_new'>Skripteinstellungen</a>" werden die Einstellungen zu den Skripten vorgenommen.<br><br>
Hier knnen der Anrufbeantworter, Callback/Callthrough Regeln, usw. eingestellt werden. Also alles, was mit den Skripten zu tun hat.<br>

Alle Skripte binden diese Datei ein. Das Webinterface ebenfalls, um Einstellungen am Editor vorzunehmen zu knnen (Zeilen/Wrap).<br>
<br>
Die Datei ist kommentiert und sollte Aufschluss ber die mglichen Schalter bieten.
EOF
fi

#
# Skripte bearbeiten
#
if [ "$HELPPAGE" = "skripte_bearbeiten" ];
then
echo '<a name="skripte_bearbeiten" href="#skripte_bearbeiten"></a>'
show_title "Skripte bearbeiten"

cat << EOF
Skripte lassen sich unter dem Menpunkt "<a href='$MAIN_CGI&page=scripts'>Skripte bearbeiten</a>" ndern/erweitern.<br><br>
Es handelt sich hierbei um Shellskripte, welche die eigentlichen Funktionen der dtmfbox beinhalten (Anrufbeantworter, Callback/Callthrough ...).<br>
<br>
Skripte, die mit "action_" beginnen, werden von <a href="$MAIN_CGI&page=help&help=menu_action">Aktionen</a> <font class='code'>[action:]</font> aufgerufen. Alle anderen Skripte werden durch das Men aufgerufen.<br>
Das Skript "userscript.sh" ist ein benutzerdefiniertes Skript, welches direkt ausgefhrt wird, bei jedem Ereignis (<a href='$MAIN_CGI&page=dtmfbox_cfg' target='_new'><font class='code'>scriptfile=</font> in dtmfbox.cfg</a>). Die jeweiligen Ereignisse bekommt das Skript per Parameter mitgeteilt (\$1 - \$9).<br><br>
Eine Erluterung zu den Ereignissen befindet sich <a href='$MAIN_CGI&page=help&help=ereignisse'>hier</a>.<br><br>
Man kann weitere Skripte unter /var/dtmfbox/script ablegen. Diese werden automatisch mitgespeichert.
EOF

fi

#
# Nachrichten
#
if [ "$HELPPAGE" = "nachrichten" ];
then
echo '<a name="nachrichten" href="#nachrichten"></a>'
show_title "Nachrichten"
cat << EOF
Der Menpunkt "<a href='$MAIN_CGI&page=am_messages' target='_new'>Nachrichten</a>" zeigt die Aufnahmen auf dem Anrufbeantworter an.<br><br>
Es kann zwischen den einzelnen Accounts gewechselt werden. Aufnahmen lassen sich abhren und lschen.<br><br>

Wird das "FTP-Streaming" verwendet, werden die Dateien auf dem FTP-Server abgelegt und stehen dort als RAW-PCM zur verfgung (8000hz/16bit/mono). Das sind ganz normale Wave-Dateien, jedoch ohne Header.
Gespeicherte Aufnahmen sind im WAV-PCM Format (8000hz/16bit/mono).
EOF
fi

#
# Webphone
#
if [ "$HELPPAGE" = "webphone" ];
then
echo '<a name="webphone" href="#webphone"></a>'
show_title "Webphone"
cat << EOF
Unter dem Menpunkt "<a href='$MAIN_CGI&page=webphone' target='_new'>Webphone</a>" befindet sich ein Java-Applet, womit es mglich ist, ber die Weboberflche, per Headset, zu telefonieren.<br><br>

Es wird das Standard-Sounddevice verwendet. Account auswhlen, Zielrufnummer eingeben und whlen.<br><br>

<i>Achtung:</i> Alpha!! ;-)<br><br>

Fr das Webphone wird die Java Runtime Engine bentigt.<br>
Download hier: <a href="http://www.java.com/de/download/" target="_new">http://www.java.com/de/download/</a><br>

EOF
fi

#
# dtmfbox Befehle
#
if [ "$HELPPAGE" = "befehle" ];
then
echo '<a name="befehle" href="#befehle"></a>'
show_title "Befehle"
cat << EOF
Die dtmfbox und dessen Plugins stellen eine Reihe von Befehlen zur Verfgung, welche ber Kommandozeile oder ber eine Funktion innerhalb der Plugins augerufen werden knnen.<br><br>
Um Befehle auszufhren, muss die dtmfbox gestartet worden sein.<br><br>
EOF

echo "Standard-Befehle (<font class='code'>dtmfbox</font>):"
echo -n "<pre class='code'>"
if [ ! -z "$(pidof "dtmfbox")" ]; then
	/var/dtmfbox/dtmfbox
else
	echo -n "dtmfbox wurde nicht gestartet!"
fi
echo "</pre>"
echo "<br>Plugins (<font class='code'>dtmfbox -list plugins</font>):"
echo -n "<pre class='code'>"
if [ ! -z "$(pidof "dtmfbox")" ]; then
	/var/dtmfbox/dtmfbox -list plugins
else
	echo -n "dtmfbox wurde nicht gestartet!"
fi
echo -n "</pre>"

fi

#
# dtmfbox Befehle
#
if [ "$HELPPAGE" = "ereignisse" ];
then
echo '<a name="ereignisse" href="#ereignisse"></a>'
show_title "Ereignisse"
cat << EOF
Ereignisse stellen den aktuellen Zustand der Verbindung dar. <br><br>
Hierber kann man feststellen, ob eine Verbindung gerade aufgebaut wird (<font class='code'>CONNECT</font>), ob ein DTMF-Zeichen empfangen wurde (<font class='code'>DTMF</font>), ob aufgelegt wurde (<font class='code'>DISCONNECT</font>), usw...
Zudem stehen einem noch weitere Informationen zur Verfgung, wie die Account-ID, Account-MSN/-Nummer, die Anrufernummer, Connection-ID, usw.<br><br>

In Mens knnen Ereignisse als Platzhalter an Skripts und Libraries bergeben werden (%event%, %type%, ...).<br>
Im benutzerdefinierten Skript "userscript.sh", stehen die Ereignisse als Parameter zur Verfgung (\$1 - \$9).<br>
Plugins haben eine eingebaute Ereignis-Funktion, die automatisch vom Programm aufgerufen wird.<br><br>

bersicht der Ereignisse:<br>
<pre class='code'>
\$1 = %event%		// Aktuelles Ereignis (DDI, EARLY, CONNECT, CONFIRMED, UNCONFIRMED, DISCONNECT)
\$2 = %direction%	// Verbindungsrichtung (INCOMING, OUTGOING)
\$3 = %type%		// Verbindungstyp (CAPI, VOIP, USER)
\$4 = %src_id%		// Source Connection-ID (eigene Verbindungs-ID)
\$5 = %dst_id%		// Target Connection-ID (Gesprchspartner-ID)
\$6 = %src_no%		// Rufnummer (Account/MSN)
\$7 = %dst_no%		// Anrufer oder Zielrufnummer
\$8 = %acc_id%		// Account-ID
\$9 = %data%		// DTMF-Zeichen, wenn %event%=DTMF (Aktuell, einzelnes Zeichen), bzw. Statuscode

%dtmf%			// DTMF-Zeichen (Buffer, gesammelte Zeichen). Wird nicht an userscript.sh bergeben!
</pre>

Parameter \$4 (%src_id%) ist einer der wichtigsten Parameter. Es ist die eigene Verbindungs-ID, welche fr fast alle Befehle gebraucht wird (z.B. Wave-Datei abspielen/aktuelle Verbindung: <font class='code'>\$DTMFBOX \$4 -play /var/play/song.wav</font>).<br><br>
Parameter \$5 (%dst_id%) ist die Verbindungs-ID des Gesprchspartners, mit dem man verbunden ist. Bei mehreren Gesprchspartnern, wird immer nur der Erste bergeben.<br><br>
Parameter \$9 (%data%) gibt zustzlich bei %event%=DISCONNECT den Grund fr den Verbindungsabbau/-abbruch an (SIP/CAPI Statuscode).<br>
EOF
fi

#
# Inhalt / Menleiste
#
cat << EOF
  </td>
  <td valign="top" width="15%">
<p></p><br>
<b>Hilfe</b>
<hr color="black">
  <ul>
	<li><a href="$MAIN_CGI&page=help&help=vorwort">Vorwort</a></li>
	<li><a href="$MAIN_CGI&page=help&help=getting_started">Getting started...</a></li>
	<br>
	<li><a href="$MAIN_CGI&page=help&help=status">Status</a></li>
	<li><a href="$MAIN_CGI&page=help&help=basiseinstellungen">Basiseinstellungen</a>
	<ul>
		<li><a href="$MAIN_CGI&page=help&help=accounts">Accounts einrichten</a></li>		
		<li><a href="$MAIN_CGI&page=help&help=internes_menu">Internes Men</a></li>
	</ul>
	</li>

	<li><a href="$MAIN_CGI&page=help&help=menu">Men bearbeiten</a>
	<ul>
		<li><a href="$MAIN_CGI&page=help&help=menu_menu">menu:</a></li>
		<li><a href="$MAIN_CGI&page=help&help=menu_script">script:</a></li>
		<li><a href="$MAIN_CGI&page=help&help=menu_lib">lib:</a></li>
		<li><a href="$MAIN_CGI&page=help&help=menu_action">action:</a></li>
	</ul>
	</li>

	<li><a href="$MAIN_CGI&page=help&help=skripteinstellungen">Skripteinstellungen</a></li>
	<li><a href="$MAIN_CGI&page=help&help=skripte_bearbeiten">Skripte bearbeiten</a></li>
	<br>
	<li><a href="$MAIN_CGI&page=help&help=nachrichten">Nachrichten</a></li>
	<li><a href="$MAIN_CGI&page=help&help=webphone">Webphone</a></li>
	<br>
	<li><a href="$MAIN_CGI&page=help&help=befehle">dtmfbox Befehle</a></li>
	<li><a href="$MAIN_CGI&page=help&help=ereignisse">dtmfbox Ereignisse</a></li>
  </ul><br>

  </td></tr></table>
  </body>
  </html>
EOF
