#!/var/tmp/sh
#####################################################################

# usb or not?
if [ "$DTMFBOX_PATH" = "" ] || [ "$DTMFBOX_PATH" = "/var/dtmfbox" ] || [ "$DTMFBOX_PATH" = "/var/dtmfbox-bin" ]; then
  GOT_USB=0
else
  GOT_USB=1
fi

CONFIG_FILES="/var/dtmfbox/dtmfbox.cfg /var/dtmfbox/menu.cfg /var/dtmfbox/script.cfg"
SCRIPT_FILES="/var/dtmfbox/script/*.sh"
ADDONS_FILES="/var/dtmfbox/script/addons/*.sh"

FILE_UUE="dtmfbox_data.uue"
FILE_STATUS=""

DEBUG_CFG="/var/flash/debug.cfg"
DEBUG_CFG_TMP="/var/tmp/debug_cfg.tmp"
BOOT_CFG="$DTMFBOX_PATH/boot.sh"

if [ "$TEXTAREA_ROWS" = "" ]; then TEXTAREA_ROWS="20"; fi
if [ "$TEXTAREA_WRAP" = "" ]; then TEXTAREA_WRAP="off"; fi

#####################################################################

FILE_START_TAG="########## -= dtmfbox settings - DO NOT EDIT - S =- ##########"
FILE_END_TAG="########## -= dtmfbox settings - DO NOT EDIT - E =- ##########"
FILE_START_TAG_MKDIR="mkdir -p /var/tmp 2>/dev/null"
FILE_START_TAG_DATA="cat > /var/tmp/$FILE_UUE << 'END_DTMFBOX_DATA'"
FILE_END_TAG_DATA="END_DTMFBOX_DATA"

#####################################################################

FILE_START_VARIABLES="
export DTMFBOX_PATH='$DTMFBOX_PATH'
export DTMFBOX_ENABLED='$DTMFBOX_ENABLED'
export DTMFBOX_WEBIF_PASS='`cat /var/dtmfbox/httpd/httpd.conf 2>/dev/null`'
export DTMFBOX_VERSION='$DTMFBOX_VERSION'
export DTMFBOX_WWW='$DTMFBOX_WWW'
export DTMFBOX_WWW_DL_FILE='$DTMFBOX_WWW_DL_FILE'
if [ \"\$DTMFBOX_PATH\" = \"\" ] || [ \"\$DTMFBOX_PATH\" = \"/var/dtmfbox\" ]; then DTMFBOX_PATH=\"/var/dtmfbox-bin\"; fi"

#####################################################################

FILE_START_PING="
if [ \"\$DTMFBOX_PATH\" = \"/var/dtmfbox-bin\" ] || [ ! -f \"\$DTMFBOX_PATH/rc.dtmfbox\" ];
then
	mkdir -p \"\$DTMFBOX_PATH\"
	cd \"\$DTMFBOX_PATH\"

	# wait, till internet connection is ready
	let cnt=0;
	while !(ping -c 1 fritz.v3v.de); do
		if [ \$cnt -eq 30 ]; then break; fi
		let cnt=cnt+1; 
		sleep 10
	done

	# wget rc.dtmfbox
	wget \"\$DTMFBOX_WWW/rc.dtmfbox\"
	chmod +x ./rc.dtmfbox

	# wget busybox-tools (when needed)
	./rc.dtmfbox check_busybox
	if [ ! -s /var/tmp/busybox-tools ]; then
		wget \"\$DTMFBOX_WWW/busybox-tools\"
		chmod +x ./busybox-tools
	fi
fi
"

#####################################################################

FILE_START_USB="
(
 # USB-Mount abwarten (max. 300 sec)
 let cnt=0;
 while [ ! -f \"$BOOT_CFG\" ]; do 
	if [ \$cnt -eq 30 ]; then break; fi
	let cnt=cnt+1; 
	sleep 10
 done;
)
sleep 30; sh \"$BOOT_CFG\"
"

#####################################################################

if [ "$FREETZ" = "0" ];
then
	RC_PREFIX="."
else
	RC_PREFIX="/etc/init.d"
fi


FILE_START="
mkdir -p \$DTMFBOX_PATH
cd \$DTMFBOX_PATH
if [ -f \"$RC_PREFIX/rc.dtmfbox\" ]; 
then
	rm /var/dtmfbox 2>/dev/null
	ln -sf "\$DTMFBOX_PATH" "/var/dtmfbox"
	export PATH=/var/dtmfbox:\$PATH

	# install dtmfbox
	$RC_PREFIX/rc.dtmfbox install bypath

	# decode/unpack configuration...
	$UUDECODE "/var/tmp/$FILE_UUE" | $GUNZIP -f -c | $TAR xv -C / -f -
	rm /var/tmp/$FILE_UUE 2>/dev/null

	# start webinterface (set password)
	if [ ! -z \"\$DTMFBOX_WEBIF_PASS\" ]; then echo \"\$DTMFBOX_WEBIF_PASS\" > /var/dtmfbox/httpd/httpd.conf; fi
	$RC_PREFIX/rc.dtmfbox start_httpd  

	# start dtmfbox
	if [ \"\$DTMFBOX_ENABLED\" = \"1\" ] || [ \"\$DTMFBOX_ENABLED\" = \"on\" ] || [ \"\$DTMFBOX_ENABLED\" = \"yes\" ];
	then
		$RC_PREFIX/rc.dtmfbox start
	fi
fi
"

#####################################################################

do_compress() {

  # save (ALL_FILES --> TAR --> TAR.GZ --> UUE)
  # tar, GZIP and uuencode files
  $TAR c -O $CONFIG_FILES $SCRIPT_FILES $ADDONS_FILES | $GZIP -f - | $UUENCODE - > "/var/tmp/$FILE_UUE"
  
  if [ -f "/var/tmp/$FILE_UUE" ]; 
  then

  # recreate debug.cfg
  # search for start-tag/end-tag, remove old data and insert new. 
  let START_FOUND=0
  let END_FOUND=0
  while read line; 
  do
	if [ $START_FOUND -eq 0 ]; 
	then
		if [ "$FILE_START_TAG" = "$line" ]; then 
			# start tag found! stop writing!
			let START_FOUND=1; 
		else
			# no start tag found? then write to file...
			echo $line;
		fi
	fi

	if [ $START_FOUND -eq 1 ]; 
	then
		if [ "$FILE_END_TAG" = "$line" ]; then 
			if [ $END_FOUND -eq 0 ];
			then
 				# insert new data
		          	if [ "$GOT_USB" = "0" ];
        		  	then
				 	echo "$FILE_START_TAG"
					echo "$FILE_START_TAG_MKDIR"
	 			  	echo "$FILE_START_TAG_DATA"
				  	cat "/var/tmp/$FILE_UUE"
				  	echo "$FILE_END_TAG_DATA"
				  	echo "$FILE_START_VARIABLES"
				  	if [ "$FREETZ" = "0" ]; then echo "$FILE_START_PING"; fi
				  	echo "$FILE_START"
				  	echo "$FILE_END_TAG"
				else
			  		echo "$FILE_START_TAG"
 	      				echo "$FILE_START_USB"
		  			echo "$FILE_END_TAG"
				fi
			fi

			# resume writing...
			let START_FOUND=0
			let END_FOUND=1
		fi
	fi
  done < "$DEBUG_CFG" > "$DEBUG_CFG_TMP"

  # new? then add data to the end of the file
  if [ $END_FOUND -eq 0 ]; 
  then
	if [ "$GOT_USB" = "0" ];
        then
		echo "$FILE_START_TAG" 		>> "$DEBUG_CFG_TMP"
		echo "$FILE_START_TAG_DATA" 	>> "$DEBUG_CFG_TMP"
		echo "$FILE_START_TAG_MKDIR"	>> "$DEBUG_CFG_TMP"
		cat "/var/tmp/$FILE_UUE" 	>> "$DEBUG_CFG_TMP"
		echo "$FILE_END_TAG_DATA" 	>> "$DEBUG_CFG_TMP"
		echo "$FILE_START_VARIABLES"	>> "$DEBUG_CFG_TMP"
 	      	if [ "$FREETZ" = "0" ]; then 	echo "$FILE_START_PING"		>> "$DEBUG_CFG_TMP"; fi
 	      	echo "$FILE_START"		>> "$DEBUG_CFG_TMP"
		echo "$FILE_END_TAG" 		>> "$DEBUG_CFG_TMP"
	else
  		echo "$FILE_START_TAG" 		>> "$DEBUG_CFG_TMP"
 	      	echo "$FILE_START_USB"		>> "$DEBUG_CFG_TMP"
		echo "$FILE_END_TAG" 		>> "$DEBUG_CFG_TMP"
	fi
  fi

  if [ "$GOT_USB" = "1" ];
  then
		echo "$FILE_START_TAG" 		> "$BOOT_CFG"
		echo "$FILE_START_TAG_MKDIR" 	>> "$BOOT_CFG"
		echo "$FILE_START_TAG_DATA" 	>> "$BOOT_CFG"
		cat "/var/tmp/$FILE_UUE" 	>> "$BOOT_CFG"
		echo "$FILE_END_TAG_DATA" 	>> "$BOOT_CFG"
	    	echo "$FILE_START_VARIABLES"	>> "$BOOT_CFG"
 	    	if [ "$FREETZ" = "0" ]; then	echo "$FILE_START_PING"		>> "$BOOT_CFG"; fi
 	    	echo "$FILE_START"		>> "$BOOT_CFG"
		echo "$FILE_END_TAG" 		>> "$BOOT_CFG"
  fi

  #calculate file sizes
  FILE_UCMP_SIZE="`$DU -c $CONFIG_FILES $SCRIPT_FILES $ADDONS_FILES | grep 'total' | sed -r 's/(.*)\t.*/\1/g'`" 
  FILE_CMP_SIZE="`$DU /var/tmp/$FILE_UUE | sed -r 's/(.*)\t.*/\1/g'`"
  FILE_STATUS="Gespeichert: $FILE_UUE (Ungepackt: $FILE_UCMP_SIZE kb, Gepackt: $FILE_CMP_SIZE kb)"

  let FILE_SIZE_DEBUG="`$DU $DEBUG_CFG_TMP | sed -r 's/(.*)\t.*/\1/g'`"
  let FILE_SIZE_DEBUG=$FILE_SIZE_DEBUG*1024

  if [ $FILE_SIZE_DEBUG -ge $DTMFBOX_MAX_SAVE_LIMIT ];
  then
    	  # maximum file size reached! Abort!
          FILE_STATUS="<font color='red'><b>Fehler! Maximale Gre der /var/flash/debug.cfg erreicht! Erlaubt: $DTMFBOX_MAX_SAVE_LIMIT Bytes, Aktuell: $FILE_SIZE_DEBUG Bytes</b></font>"
  else  
	  # check for changes in /var/flash/debug.cfg
	  F1="`cat $DEBUG_CFG_TMP`"
	  F2="`cat $DEBUG_CFG"`"
	
	  if [ "$F1" != "$F2" ];
	  then
	  	# save new debug.cfg ...
		cat "$DEBUG_CFG_TMP" > "$DEBUG_CFG"
	  else
	        # no changes ...
	        FILE_STATUS="$FILE_STATUS <font size=1>(/var/flash/debug.cfg unverndert --> USB)</font>"
	  fi
  fi
	
  # ... and remove temporary files
  rm "$DEBUG_CFG_TMP" 2>/dev/null
  rm "/var/tmp/$FILE_UUE" 2>/dev/null

  else
    FILE_STATUS="<font color='red'><b>Fehler! $FILE_UUE kann nichz erzeugt werden!</font>"
  fi
}

#####################################################################

do_uninstall() {

  # recreate debug.cfg
  # search for start-tag/end-tag and remove data
  let START_FOUND=0
  let END_FOUND=0
  while read line; 
  do
	if [ $START_FOUND -eq 0 ]; 
	then
		if [ "$FILE_START_TAG" = "$line" ]; then 
			# start tag found! stop writing!
			let START_FOUND=1; 
		else
			# no start tag found? then write to file...
			echo $line;
		fi
	fi

	if [ $START_FOUND -eq 1 ]; 
	then
		if [ "$FILE_END_TAG" = "$line" ]; then 
			# resume writing...
			let START_FOUND=0
			let END_FOUND=1
		fi
	fi
  done < "$DEBUG_CFG" > "$DEBUG_CFG_TMP"
  cat "$DEBUG_CFG_TMP" > "$DEBUG_CFG"  
}

#####################################################################

# read post variables
read -r recv_data
recv_data=`echo $recv_data | sed -e 's/&/ /g'`

# other file selected?
for var in $recv_data; do
	FILE_SELECT=$(echo $var | grep 'ffile_sel=' | sed -e 's/ffile_sel\=//' -e 's/\&.*//g')
	FILE_SELECT=$(echo "$FILE_SELECT" | sed -e "s/%0D//g" -e "s/%0A/\n/g")
	FILE_SELECT=$($HTTPD -d "$FILE_SELECT")

	# selected another file?
	if [ "$FILE_SELECT" != "" ]; 
	then
		FILE_EDIT="$FILE_SELECT"
		FILE_STATUS="$FILE_SELECT"
	fi

	# selected another section?
	if [ "$SECT_SELECT" = "" ]; 
	then
		SECT_SELECT=$(echo $var | grep 'fsect_sel=' | sed -e 's/fsect_sel\=//' -e 's/\&.*//g')
		SECT_SELECT=$(echo "$SECT_SELECT" | sed -e "s/%0D//g" -e "s/%0A/\n/g")
		SECT_SELECT=$($HTTPD -d "$SECT_SELECT")
	fi	

	# restart dtmfbox?
	if [ "$DTMFBOX_REBOOT" != "dtmfbox_reboot" ];
	then
		DTMFBOX_REBOOT=$(echo $var | grep 'check_reboot=' | sed -e 's/check_reboot\=//' -e 's/\&.*//g')
		DTMFBOX_REBOOT=$(echo "$DTMFBOX_REBOOT" | sed -e "s/%0D//g" -e "s/%0A/\n/g")
		DTMFBOX_REBOOT=$($HTTPD -d "$DTMFBOX_REBOOT")
		if [ "$DTMFBOX_REBOOT" = "dtmfbox_reboot" ]; then
			CHECK_REBOOT="1";
		else
			if [ "$CHECK_REBOOT" = "" ]; then CHECK_REBOOT="0"; fi
			if [ "$CHECK_REBOOT" = "1" ]; then CHECK_REBOOT="0"; fi
		fi
	fi
done

# select first file, if none is selected
if [ "$FILE_EDIT" = "" ]; then
	for var in $SCRIPT_FILES $CONFIG_FILES $ADDONS_FILES; do
		if [ -f "$var" ]; then
			FILE_SELECT="$var"
			FILE_EDIT="$var"
			FILE_STATUS="$FILE_SELECT"
			break;
		fi
	done
fi
if [ "$FILE_POS" = "" ]; then FILE_POS="0"; fi
if [ "$FILE_STATUS" = "" ]; then FILE_STATUS="$FILE_EDIT"; fi

# save changes
for var in $recv_data; do
  if [ "$FILE_DATA" = "" ]; then

    # convert data
    FILE_DATA=$(echo $var | grep 'edit=' | sed -e 's/edit\=//' -e 's/\&.*//g')
    FILE_DATA=$(echo "$FILE_DATA" | sed -e "s/%0D//g" -e "s/%0A/\n/g")
    FILE_DATA=$($HTTPD -d "$FILE_DATA")

    if [ "$FILE_DATA" != "" ]; 
    then
      # save modifications to file
      echo "$FILE_DATA" > "$FILE_EDIT"
      chmod +x "$FILE_EDIT"

      # compress data and save to flash
      do_compress;
    fi
  fi
done

#####################################################################

# $1=UNINSTALL 
# uninstall dtmfbox (by script)
if [ "$1" = "UNINSTALL" ]; then 
	do_uninstall; 
	return 1; 
fi;

# $1=SAVE 
# save changes (by script)
if [ "$1" = "SAVE" ]; then
	do_compress;
	return 1;
fi

#####################################################################

echo "<table border='0' cellpadding='3' cellspacing='0' width='95%' bordercolor='#005588'>"
echo "  <tr><td style='background-color:#005588'><font size='2' color='white'><b>$FILE_STATUS</b></font></td></tr><tr><td height='5'</td></tr>"
echo "</table>"

echo "<form name='ffile'  method='post'>"
echo "<input type='hidden' name='dummy' value='0'>"

cat << EOF
<script language='javascript'>
	function trim(val)
	{
		return val.replace(/ +/g, ' ').replace(/^\s+/g, '').replace(/\s+$/g, '');
	}

	function comment_opts(comment, opt, remove_comment)
	{
		var regex = "/(.*)\\\[" + opt + ":(.*)\\\](.*)/";
		var retval = '';

		if(comment.match(eval(regex))) {
			if(!remove_comment)
				retval = comment.replace(eval(regex), "\$2");
			else
				retval = comment.replace(eval(regex), "\$1 \$3");
		}

		return retval;
	}

	function parse_text(comment_prefix, add_quotes) 
	{
		var text=document.forms.feditor.edit.value;
		var lines = text.split("\n");				// split rows
		var i;
		var in_section = "";
		var in_range = "";

		comment_prefix = comment_prefix.replace(/\//g, "\\\/");	// escape comment

		document.write("<div id='sections_div'><b>Section: </b><select id='sections' name='sections' onchange='javascript:on_section_change(this)'></select><p></p></div>");
		document.write("<div><table border='0' cellpadding='3' cellspacing='0' width='95%'>");

		for(i=0; i<lines.length; i++)				// walkthrough rows
		{
	  	  var comment = '';
		  
		  lines[i] = lines[i].replace(/\r/g, "");		// remove 0x13
	
 		  // [HTML:...]
		  var html = comment_opts(trim(lines[i]), "HTML", false); 
 		  if(html.length) {
		  	document.write("<tr><td colspan='3'>" + html + "</td></tr>");
			lines[i] = comment_opts(trim(lines[i]), "HTML", true); 
		  }
		
	 	  // remove comments!
		  if(lines[i].match(eval('/' + comment_prefix + '/'))) {
			comment = lines[i].replace(eval('/.*' + comment_prefix + '/'), "");
		  	lines[i] = lines[i].replace(eval('/' + comment_prefix + '.*/'), "");
		  } 
	
 		  // [section] found!
		  if(lines[i].match(/\[.*\]/)) 
		  {	
			in_section = trim(lines[i]);
			var newOption = document.createElement("option");
			newOption.appendChild(document.createTextNode(in_section));
			newOption.value = in_section;
			document.feditor2.sections.appendChild(newOption);

			document.write("</table>");
			document.write("</div>");
			document.write("<div id='" + in_section + "' style='display:none'>");
			document.write("<table border='0' cellpadding='3' cellspacing='0' width='95%'>");

		  } 

		  // key=value found!
		  if(!lines[i].match(/\[.*\]/)) 
		  {			
			if(lines[i].length != 0) 
			{
				var key = lines[i].replace(/=.*/g, "");
				var val = lines[i].replace(/.*=/g, "");				
				val = trim(val); key = trim(key);

				if(add_quotes) 
					val = val.replace(/\"(.*)\"/g, "\$1");

				// [OPTION:value1|caption1,value2|caption2,...]
				var options = comment_opts(comment, "OPTION", false); 
	
				// [HIDE]
				var hide = comment_opts(comment, "HIDE", false);
	
				// [WIDTH:xxx]
				var width = comment_opts(comment, "WIDTH", false);
				if(width.length) comment = comment_opts(comment, "WIDTH", true);
				else width = '95%';

				if(!comment.length) {
					comment = key;
					col1_width='';
				} else {
					col1_width='300px'
				}

				if(hide!='1' && options.length)
				{
					comment = comment_opts(comment, "OPTION", true);
	
					document.write("<tr>");
					document.write("<td width='" + col1_width + "'>" + comment + "</td> <td><select name='" + key + "_CFGLINE_" + i + "' value='" + val + "' onchange=\"javascript:on_text_change(this, '" + comment_prefix + "', " + add_quotes + ")\">");
	
					var opts = options.split(",");
					var j;
	
					for(j=0; j<opts.length; j++) {					
						var opts2 = opts[j].split("|");
						val_selected = "";
						if(opts2[0] == val) val_selected = "selected";
	
						document.write("<option value='" + opts2[0] + "' " + val_selected + ">" + opts2[1] + "</option>");
					}
					document.write("</select></td><td></td>");
					document.write("</tr>");				
					continue;
				} 
	
				else if(hide!='1') {
					document.write("<tr>");
					document.write("<td width='" + col1_width + "'>" + comment +  "</td> <td><input type='text' name='" + key + "_CFGLINE_" + i + "' value='" + val + "' onchange=\"javascript:on_text_change(this, '" + comment_prefix + "'," + add_quotes + ")\" style='width:" + width + "'></td>");

					if("$SHOW_ADD_REMOVE" == "1") {
						document.write("<td width='115px' align='center'>");
						document.write("<input type='button' name='ADD_" + i + "' style='width:35px' value='ADD' onclick='javascript:on_text_add(this, " + add_quotes + ")'> ");
						document.write("<input type='button' name='REN_" + i + "' style='width:35px' value='REN' onclick='javascript:on_text_rename(this, " + add_quotes + ")'> ");
						document.write("<input type='button' style='width:35px' name='DEL_" + i + "' value='DEL' onclick='javascript:on_text_delete(this)'> ");
						document.write("</td>");
					} else {
						document.write("<td></td>");
					}

					document.write("</tr>");		
					continue;
				}
			}
		  }
		}
	        document.write("</table></div>");
	}


	function on_text_rename(obj, add_quotes)
	{
		var key_line = obj.name;
		var line = key_line.replace(/REN_/g, "");

		var text=document.forms.feditor.edit.value;
		var lines = text.split("\n");				// split rows

		new_val=prompt('ndern:', lines[line]);
		if(new_val == null) return;
		
		lines[line] = new_val;
		text = lines.join("\n");		
		document.forms.feditor.edit.value = text;
		//document.forms.feditor.submit();
		do_submit();

	}

	function on_text_delete(obj)
	{
		var key_line = obj.name;
		var line = key_line.replace(/DEL_/g, "");

		var text=document.forms.feditor.edit.value;
		var lines = text.split("\n");				// split rows

		if(confirm(lines[line] + '\n\n' + 'lschen?')) 
		{
			lines.splice(line, 1);				// remove line from array
			text = lines.join("\n");		
			document.forms.feditor.edit.value = text;
			//document.forms.feditor.submit();
			do_submit();
		}

	}

	function on_text_add(obj, add_quotes) 
	{
		var key_line = obj.name;
		var line = key_line.replace(/ADD_/g, "");

		var text=document.forms.feditor.edit.value;
		var lines = text.split("\n");				// split rows

		new_key=prompt('"Schlssel=Wert" eingeben:');
		if(new_key == null) return;
		if(!new_key.match(/=/)) { alert(new_key + ' ungltig!'); return; }

		if(confirm(new_key + '\n\n' + 'hinzufgen?')) 
		{
			lines[line] = lines[line] + '\n' + new_key;

			text = lines.join("\n");		
			document.forms.feditor.edit.value = text;
			//document.forms.feditor.submit();
			do_submit();
		}
	}

	function on_text_change(obj, comment_prefix, add_quotes)
	{
		var key_line = obj.name;
		var key = key_line.replace(/_CFGLINE_.*/g, "");
		var line = key_line.replace(/.*_CFGLINE_/g, "");

		var text=document.forms.feditor.edit.value;
		var lines = text.split("\n");				// split rows
		var comment = '';

		comment_prefix_escaped = comment_prefix.replace(/\//g, "\\\/"); // escape comment
 
		// Re-Add comment
		if(lines[line].match(eval('/' + comment_prefix_escaped + '/')))	
		{
		  var tmp = lines[line];
		  var i;
		  var startFound = false;
		  var endFound = 0;
		  var searchQuotes = false;

		  // try to find comment and cut it out
		  if(add_quotes) {
			  if(tmp.match(/.*=\\"/)) { searchQuotes=true; startFound = false; }
			  else startFound = true;
	          } else {
			startFound = true;
		  }

  		  for(i=1; i<tmp.length; i++) 
		  {
			var c1 = tmp.substr(i-1, 1);
			var c2 = tmp.substr(i, 1);
 
			if(searchQuotes && (c1 != "\\\" && c2 == "\"")) {
				if(startFound) { endFound = i+1; break; }
				else { startFound = true; }
			}

			if(!searchQuotes && (c2 == ' ' || c2 == '\\t' || c2 == "\\n"))
			{
		 		if(startFound) {
					endFound = i;
					break;
				}
			}								
		  } 

		  if(endFound != 0)		
			  comment = tmp.substr(endFound, tmp.length - endFound);
		}

		// Modify key=value, paste comment
		if(add_quotes)
			lines[line] = key + "=\"" + obj.value.replace(eval('/' + comment_prefix_escaped + '.*/'), "") + "\"" + comment;
		else 
			lines[line] = key + "=" + obj.value.replace(eval('/' + comment_prefix_escaped + '.*/'), "") + comment;

		// Join text and modify textarea
		text = lines.join("\n");		
		document.forms.feditor.edit.value = text;
	}

	function on_section_change(obj)
	{
		var secdiv = document.getElementById(obj.value);

		if(secdiv) {
			for(i=0; i<obj.options.length; i++) {				
				var tmpdiv = document.getElementById(obj.options[i].value);
				if(tmpdiv) tmpdiv.style.display = 'none';
			}

			secdiv.style.display = 'block';
		}
	}
</script>
EOF

if [ "$SHOW_FILE_SELECTION" != "0" ];
then	
	echo "<select name='ffile_sel' onChange='javascript:submit()' style='width:95%'>"
	
	if [ "$SHOW_CONFIG_FILES" != "0" ];
	then
	  for var in $CONFIG_FILES; do
		if [ -f "$var" ]; then
			if [ "$FILE_EDIT" = "$var" ]; then file_selected="selected"; else file_selected=""; fi
	        	FILE=`echo "$var" | sed 's/\/var\/dtmfbox\//CONFIG>> /g'`
			echo "<option $file_selected value=\"$var\">$FILE</option>";
		fi
	  done
	fi
	
	if [ "$SHOW_SCRIPT_FILES" != "0" ];
	then
	  for var in $SCRIPT_FILES $ADDONS_FILES; do
		if [ -f "$var" ]; then
			if [ "$FILE_EDIT" = "$var" ]; then file_selected="selected"; else file_selected=""; fi
			echo "<option $file_selected value=\"$var\">$var</option>";
		fi
	  done
	fi
	echo "</select>"
else
	echo "<input type='hidden' name='ffile_sel' value='$FILE_SELECT'>"
	echo "<input type='hidden' name='fsect_sel' value='$SECT_SELECT'>"
fi
echo "<input type='hidden' name='dummy2' value='0'>"
echo "</form>"

echo "<form name='feditor' method='post'>"
echo "<div id='edit_div' style='display:none'>"
echo -n "<textarea name='edit' id='edit' style='width:95%' rows='$TEXTAREA_ROWS' cols='80' wrap='$TEXTAREA_WRAP'>"
cat "$FILE_EDIT" | sed 's/&/&amp;/g'
echo -n "</textarea>"
echo "<br>"
echo "</div>"

echo "<div style='display:none'>"
echo "<input type='hidden' name='dummy' value='0'>"
echo "<input type='hidden' name='ffile_sel' value='$FILE_EDIT'>"
echo "<input type='hidden' name='fsect_sel' value='$SECT_SELECT'>"
echo "<input type='hidden' name='check_reboot' value='dtmfbox_reboot'>"
echo "<input type='hidden' name='dummy2' value='0'>"
echo "</div>"
echo "</form>"

if [ "$DIRECT_EDIT" = "0" ];
then
cat << EOF
<form name="feditor2">
<script language="javascript">	

	if("$COMMENT_PREFIX" == "#") parse_text("$COMMENT_PREFIX", true);
	if("$COMMENT_PREFIX" == "//") parse_text("$COMMENT_PREFIX", false);

	document.getElementById('edit_div').style.display = 'none';
	if(document.getElementById('sections').options.length > 0) {
		try {
			var obj = document.getElementById('sections');
			if("$SECT_SELECT" != "") 
				obj.value = "$SECT_SELECT";
			else
				obj.selectedIndex = 0;

			on_section_change(obj)	
		} catch(e) {}
	} else {
		document.getElementById('sections_div').style.display = 'none';	
	}
</script>
</form>
<br>
<table border='0' width='95%'>
<tr><td><div align='right'><a href='$MAIN_CGI&page=$PAGE&direct_edit=1'>Text-Editor</a></div></td></tr>
<tr><td><hr color='black' align='left'></td></tr>
</table>
EOF
else
cat << EOF
<script language="javascript">	
	document.getElementById('edit_div').style.display = 'block';
</script>
<table border='0' width='95%'><tr><td>
<div align='right'><a href='$MAIN_CGI&page=$PAGE&direct_edit=0'>Text-Editor verlassen</a></div>
</td></tr></table>
EOF
fi

cat << EOF
<script language="javascript">
	function do_submit() 
	{
		var obj=document.getElementById('check_reboot');

		try {
			if(obj.checked) document.forms.feditor.check_reboot.value = "dtmfbox_reboot";
			else document.forms.feditor.check_reboot.value = "";
		} catch(e) {}

		try { document.forms.feditor.fsect_sel.value = document.getElementById('sections').value; } catch(e) {}
		try { this.ffile_sel = document.forms['ffile'].ffile_sel.value; } catch(e) {}
		document.forms.feditor.submit();
	}
</script>
EOF

echo "<table border='0' width='95%'><tr>"
echo "<td align='left'><input type='button' value='Speichern' style='width:100px' onclick=\"javascript:do_submit();\"></td>"
if [ "$SHOW_REBOOT" != "0" ]; 
then
  if [ "$CHECK_REBOOT" = "1" ]; then dtmfbox_reboot="checked"; else dtmfbox_reboot=""; fi
  if [ -z "$(pidof "dtmfbox")" ]; then dtmfbox_reboot=""; dtmfbox_status="<font color='red' size='1'><br><b>stopped</b></font>"; else dtmfbox_status="<font color='green' size='1'><br><b>running</b></font>"; fi
  echo "<td align='right'><input type='checkbox' id='check_reboot' name='check_reboot' value='dtmfbox_reboot' $dtmfbox_reboot>dtmfbox neu starten $dtmfbox_status</td>"
fi
echo "</tr></table>"
echo "<input type='hidden' name='dummy3' value='0'>"

# restart dtmfbox?
if [ "$DTMFBOX_REBOOT" = "dtmfbox_reboot" ];
then
	echo -n "<pre>"
	/var/dtmfbox/rc.dtmfbox restart
	echo -n "</pre>"
fi 
